******************************************************************************
*                                                                            *
*                                    NoReq                                   *
*                                                                            *
*                        Copyright 1990 Jonathan Potter                     *
*                                                                            *
* This is a short (92 byte) utility you can use to turn off the annoying DOS *
* requesters. Running it once turns the requesters off, and running it again *
* turns them back on.                                                        *
*                                                                            *
* The best place that I can see to use this would be around IF statements;   *
* for example :                                                              *
*                                                                            *
* NoReq                             ; Turn requesters off                    *
* If EXISTS DH0:                    ; Check for DH0:.. if not there, DOS     *
*                                   ; would normally throw us a requester    *
*   Execute DH0:S/HD-Startup                                                 *
* EndIf                                                                      *
* NoReq                             ; Turn requesters back on                *
*                                                                            *
* Or if you are diskcopying from DF0: to RAD: for example. DOS normally      *
* throws up a requester, waits a second or so and then takes it away again.  *
* Annoying, so you would run NoReq around the diskcopy command.              *
*                                                                            *
* NoReq can even be made resident, so you can use it hundreds of times in    *
* your startup-sequence without increased disk access.                       *
*                                                                            *
* Enjoy!                                                                     *
*                                                                            *
*                               Jonathan Potter                              *
*                               P.O. Box 289                                 *
*                               Goodwood, SA 5034                            *
*                               Australia                                    *
*                               (08) 2932788                                 *
*                                                                            *
******************************************************************************

_LVOFindTask = -$126
pr_WindowPtr = 184

start:
	move.l 4,a6
	lea 0,a1
	jsr _LVOFindTask(a6)           ; Find myself!
	move.l d0,a0

	cmp.l #-1,pr_WindowPtr(a0)     ; -1 means show no requesters
	bne hidereq
	move.l #0,pr_WindowPtr(a0)     ; reset to 0 (requesters on Workbench screen)
	bra out

hidereq:
	move.l #-1,pr_WindowPtr(a0)    ; Hide the requesters!

out:
	moveq #0,d0
	rts                            ; And outahere
